﻿'=========================================================
'Description : PCI 16P16R product demo program for VB.NET
'DLL Version : Dii.dll V 3.0.0.1
'Release Date : 2018/08/01
'Author : Samuel Tseng
'
'Copyright 2018 Decision Computer
'All Right Reserved
'https://www.smatlab.com/catalog10.html
'=========================================================

Public Class Form1

    Private Declare Function DiiGetDevs Lib "Dii.dll" Alias "_DiiGetDevs@4" (ByVal dwTargetDevType As Integer) As Boolean

    Private Declare Function DiiEnumDevs Lib "Dii.dll" Alias "_DiiEnumDevs@16" _
    (ByVal dwDevType As Integer, ByVal dwMemberIndex As Integer, ByRef dwDevID As Integer, ByRef lpszDevName As Integer) As Boolean

    Private Declare Function DiiOpenDevice Lib "Dii.dll" Alias "_DiiOpenDevice@12" _
    (ByVal lpszDeviceName As Integer, ByVal dvType As Integer, ByVal bExclusive As Boolean) As Integer

    Private Declare Function DiiSetDigitalByte Lib "Dii.dll" Alias "_DiiSetDigitalByte@12" _
    (ByVal HANDLE As Integer, ByVal DWORD As Integer, ByVal valuex As Integer) As Boolean

    Private Declare Function DiiGetDigitalByte Lib "Dii.dll" Alias "_DiiGetDigitalByte@12" _
    (ByVal hDevice As Integer, ByVal dwPort As Integer, ByRef lpbyPortState As Integer) As Boolean



    Dim hDevice As Integer                  ' handle to device
    Dim DevType As Integer
    Dim DevId As Integer

    Dim COM_Num As String
    Dim outData, P2RoutData, P3RoutData As Byte
    Dim lResult As Boolean
    Dim output_value, output_value1 As Integer
    Dim autorun As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim dev_id As Long
        Dim dev_token As Long
        'Dim dll_result As Boolean

        If DiiGetDevs(515) Then
            Text1.Text = "PCI 16P16R Connection OK!"

            If DiiEnumDevs(515, 0, dev_id, dev_token) Then
                Text1.Text = Text1.Text & vbCrLf & "PCI 16P16R ID : " & Str(dev_id)

                hDevice = DiiOpenDevice(dev_token, 515, True)
                Text1.Text = Text1.Text & vbCrLf & "PCI 16P16R Device : " & Str(hDevice)

            Else
                Text1.Text = Text1.Text & vbCrLf & "PCI 16P16R Search failed"
            End If
        Else
            Text1.Text = "PCI 16P16R connection failed!"
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim inp As Long
        Dim TorF As Boolean

        If hDevice = 0 Then Exit Sub

        TorF = DiiGetDigitalByte(hDevice, 0, inp)

        For i = 0 To 7
            If inp And (2 ^ i) Then
                P0P(i, Color.FromArgb(255, 0, 0))
            Else
                P0P(i, Color.FromArgb(127, 127, 127))
            End If
        Next i

        TorF = DiiGetDigitalByte(hDevice, 3, inp)

        For i = 0 To 7
            If inp And (2 ^ (i)) Then
                P1P(i, Color.FromArgb(255, 0, 0))
            Else
                P1P(i, Color.FromArgb(127, 127, 127))
            End If
        Next i
    End Sub

    Sub P1P(ByVal port As Integer, ByVal color As Color)
        Select Case port
            Case 0
                P1P0.BackColor = color
            Case 1
                P1P1.BackColor = color
            Case 2
                P1P2.BackColor = color
            Case 3
                P1P3.BackColor = color
            Case 4
                P1P4.BackColor = color
            Case 5
                P1P5.BackColor = color
            Case 6
                P1P6.BackColor = color
            Case 7
                P1P7.BackColor = color
            Case Else
                Text1.Text = "P0D input port Error"
        End Select
    End Sub

    Sub P0P(ByVal port As Integer, ByVal color As Color)
        Select Case port
            Case 0
                P0P0.BackColor = color
            Case 1
                P0P1.BackColor = color
            Case 2
                P0P2.BackColor = color
            Case 3
                P0P3.BackColor = color
            Case 4
                P0P4.BackColor = color
            Case 5
                P0P5.BackColor = color
            Case 6
                P0P6.BackColor = color
            Case 7
                P0P7.BackColor = color
            Case Else
                Text1.Text = "P0D input port Error"
        End Select
    End Sub

    Sub P2R(ByVal port As Integer)
        Dim TorF As Boolean
        If hDevice = 0 Then Exit Sub

        If output_value And (2 ^ port) Then
            output_value = output_value - (2 ^ port)
        Else
            output_value = output_value + (2 ^ port)
        End If

        TorF = DiiSetDigitalByte(hDevice, 2, output_value)

        If output_value And (2 ^ 0) Then
            P2R0.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R0.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value And (2 ^ 1) Then
            P2R1.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R1.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value And (2 ^ 2) Then
            P2R2.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R2.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value And (2 ^ 3) Then
            P2R3.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R3.BackColor = Color.FromArgb(127, 127, 127)
        End If
        '--------
        If output_value And (2 ^ 4) Then
            P2R4.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R4.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value And (2 ^ 5) Then
            P2R5.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R5.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value And (2 ^ 6) Then
            P2R6.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R6.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value And (2 ^ 7) Then
            P2R7.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P2R7.BackColor = Color.FromArgb(127, 127, 127)
        End If

    End Sub

    Sub P3R(ByVal port As Integer)
        Dim TorF As Boolean
        If hDevice = 0 Then Exit Sub

        If output_value1 And (2 ^ port) Then
            output_value1 = output_value1 - (2 ^ port)
        Else
            output_value1 = output_value1 + (2 ^ port)
        End If

        TorF = DiiSetDigitalByte(hDevice, 3, output_value1)

        If output_value1 And (2 ^ 0) Then
            P3R0.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R0.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value1 And (2 ^ 1) Then
            P3R1.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R1.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value1 And (2 ^ 2) Then
            P3R2.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R2.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value1 And (2 ^ 3) Then
            P3R3.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R3.BackColor = Color.FromArgb(127, 127, 127)
        End If
        '--------
        If output_value1 And (2 ^ 4) Then
            P3R4.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R4.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value1 And (2 ^ 5) Then
            P3R5.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R5.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value1 And (2 ^ 6) Then
            P3R6.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R6.BackColor = Color.FromArgb(127, 127, 127)
        End If
        If output_value1 And (2 ^ 7) Then
            P3R7.BackColor = Color.FromArgb(255, 0, 0)
        Else
            P3R7.BackColor = Color.FromArgb(127, 127, 127)
        End If
    End Sub

    Private Sub P3R0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R0.Click
        P3R(0)
    End Sub

    Private Sub P3R1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R1.Click
        P3R(1)
    End Sub

    Private Sub P3R2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R2.Click
        P3R(2)
    End Sub

    Private Sub P3R3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R3.Click
        P3R(3)
    End Sub

    Private Sub P3R4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R4.Click
        P3R(4)
    End Sub

    Private Sub P3R5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R5.Click
        P3R(5)
    End Sub

    Private Sub P3R6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R6.Click
        P3R(6)
    End Sub

    Private Sub P3R7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P3R7.Click
        P3R(7)
    End Sub

    Private Sub P2R0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R0.Click
        P2R(0)
    End Sub

    Private Sub P2R1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R1.Click
        P2R(1)
    End Sub

    Private Sub P2R2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R2.Click
        P2R(2)
    End Sub

    Private Sub P2R3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R3.Click
        P2R(3)
    End Sub

    Private Sub P2R4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R4.Click
        P2R(4)
    End Sub

    Private Sub P2R5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R5.Click
        P2R(5)
    End Sub

    Private Sub P2R6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R6.Click
        P2R(6)
    End Sub

    Private Sub P2R7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles P2R7.Click
        P2R(7)
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox1.CheckedChanged
        If hDevice = 0 Then Exit Sub

        If CheckBox1.Checked = True Then
            Text1.Text = Text1.Text & vbCrLf & "Automatic run"
            Timer1.Enabled = True
        Else
            Text1.Text = Text1.Text & vbCrLf & "Automatic stop"
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If hDevice = 0 Then Exit Sub

        If autorun < 8 Then

            Call P2R(autorun)
        Else
            Call P3R((autorun - 8))
        End If

        autorun = autorun + 1
        If autorun = 16 Then
            autorun = 0
        End If

        Me.Button2.PerformClick()
    End Sub
End Class
